// HexEditDlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HexEditDlg.h"
#include "HexEditDlgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHexEditDlgDlg dialog

CHexEditDlgDlg::CHexEditDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHexEditDlgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHexEditDlgDlg)
	m_nColumns = 8;
	m_nDigitsInAddr = 1;
	m_nDigitsInData = 0;
	m_bShowAddr = TRUE;
	m_bShowAscii = TRUE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bInitialized = false;
}

void CHexEditDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHexEditDlgDlg)
	DDX_Text(pDX, IDC_COLUMNS, m_nColumns);
	DDV_MinMaxInt(pDX, m_nColumns, 1, 100);
	DDX_Radio(pDX, IDC_DIGITS_IN_ADDR, m_nDigitsInAddr);
	DDX_Radio(pDX, IDC_DIGITS_IN_DATA, m_nDigitsInData);
	DDX_Control(pDX, IDC_HEXEDITCTRL1, m_ctlHexEdit);
	DDX_Check(pDX, IDC_SHOWADDR, m_bShowAddr);
	DDX_Check(pDX, IDC_SHOWASCII, m_bShowAscii);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHexEditDlgDlg, CDialog)
	//{{AFX_MSG_MAP(CHexEditDlgDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_COLUMNS, OnChangeColumns)
	ON_BN_CLICKED(IDC_COLAUTO, OnColauto)
	ON_BN_CLICKED(IDC_DIGITS_IN_ADDR, OnDigitsInAddr)
	ON_BN_CLICKED(IDC_DIGITS_IN_DATA, OnDigitsInData)
	ON_BN_CLICKED(IDC_SHOWASCII, OnShowascii)
	ON_BN_CLICKED(IDC_SHOWADDR, OnShowaddr)
	ON_BN_CLICKED(IDC_LOADDATA, OnLoaddata)
	ON_BN_CLICKED(ID_EXIT, OnExit)
	ON_BN_CLICKED(ID_SAVE, OnSave)
	ON_BN_CLICKED(IDC_NEWFILE, OnNewfile)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN1, OnDeltaposSpin1)
	ON_BN_CLICKED(IDC_DIGITS_IN_ADDR2, OnDigitsInAddr)
	ON_BN_CLICKED(IDC_DATAFORMAT2, OnDigitsInData)
	ON_BN_CLICKED(IDC_DATAFORMAT3, OnDigitsInData)
	ON_EN_KILLFOCUS(IDC_COLUMNS, OnKillfocusColumns)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHexEditDlgDlg message handlers

BOOL CHexEditDlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_bInitialized = true;
	for ( int i = IDC_COLUMNS; i <= IDC_SHOWADDR; i++)
	{
		CWnd* pWnd = GetDlgItem ( i );

		if ( pWnd )
			pWnd->EnableWindow ( FALSE );
	}
	GetDlgItem(IDC_SPIN1)->SendMessage(UDM_SETPOS,0,MAKELONG((short) m_nColumns, 0));
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHexEditDlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHexEditDlgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CHexEditDlgDlg::OnChangeColumns() 
{
	if ( m_bInitialized )
	{
		int nColumns = m_nColumns;
		if ( !UpdateData() )
		{
			m_nColumns = nColumns;
			UpdateData(FALSE);
		}
		else if ( m_nColumns > 0 )
		{
			m_ctlHexEdit.SetColumns(m_nColumns);
			GetDlgItem(IDC_SPIN1)->SendMessage(UDM_SETPOS,0,MAKELONG((short) m_nColumns, 0));
		}
		else
		{
			m_nColumns = 1;
			UpdateData(FALSE);
		}
	}
}

void CHexEditDlgDlg::OnColauto() 
{
	m_ctlHexEdit.SetColumns(0);
	m_nColumns = m_ctlHexEdit.GetColumns();
	UpdateData(FALSE);
}

void CHexEditDlgDlg::OnDigitsInAddr() 
{
	if ( m_bInitialized )
	{
		UpdateData();
		switch (m_nDigitsInAddr)
		{
		case 1:
			m_ctlHexEdit.SetShowAddress(true);
			m_ctlHexEdit.SetDigitsInAddress(8);
			break;
		case 0:
			if ( arr.GetOneDimSize() > 0x10000 )
			{
				AfxMessageBox ( _T("File is larger than 64K"), MB_ICONSTOP | MB_OK );
				m_nDigitsInAddr = 1;
				UpdateData ( FALSE );
			}
			else
			{
				m_ctlHexEdit.SetShowAddress(true);
				m_ctlHexEdit.SetDigitsInAddress(4);
			}
			break;
		}
	}
}

void CHexEditDlgDlg::OnDigitsInData() 
{
	if ( m_bInitialized )
	{
		UpdateData();
		switch (m_nDigitsInData)
		{
		case 0:	// byte
			m_ctlHexEdit.SetDigitsInData(2);
			m_bShowAscii = m_ctlHexEdit.GetShowAscii();
			UpdateData ( FALSE );
			break;
		case 2:	// dword
			m_ctlHexEdit.SetDigitsInData(8);
			m_bShowAscii = false;
			UpdateData ( FALSE );
			break;
		case 1:	// word
			m_ctlHexEdit.SetDigitsInData(4);
			m_bShowAscii = false;
			UpdateData ( FALSE );
			break;
		}
	}
}

void CHexEditDlgDlg::OnShowascii() 
{
	if ( m_bInitialized )
	{
		UpdateData();
		m_ctlHexEdit.SetShowAscii(m_bShowAscii);
		m_bShowAscii = m_ctlHexEdit.GetShowAscii();
		UpdateData(FALSE);
	}
}


void CHexEditDlgDlg::OnShowaddr() 
{
	UpdateData();
	GetDlgItem ( IDC_DIGITS_IN_ADDR ) -> EnableWindow ( m_bShowAddr );
	GetDlgItem ( IDC_DIGITS_IN_ADDR2 ) -> EnableWindow ( m_bShowAddr );
	if ( m_bInitialized )
	{
		m_ctlHexEdit.SetShowAddress(m_bShowAddr);
	}
}

void CHexEditDlgDlg::OnLoaddata() 
{
	CFileDialog dlg ( TRUE );

	if ( dlg.DoModal() == IDOK )
	{
		// read file into arr
		m_strFileName = dlg.GetPathName();
		CFile f ( m_strFileName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite );

		if ( arr.GetDim() == 0 )
		{
			for ( int i = IDC_COLUMNS; i <= IDC_SHOWADDR; i++)
			{
				CWnd* pWnd = GetDlgItem ( i );
				
				if ( pWnd )
					pWnd->EnableWindow ();
			}
		}

		// Setup the bounds and create the array
		SAFEARRAYBOUND rgsabound;
		rgsabound.cElements = f.GetLength();
		rgsabound.lLbound = 0;
		arr.Create(VT_UI1, 1, &rgsabound);		// Create doesn't assert on zero length

		void* buf;
		arr.AccessData(&buf);
		f.Read(buf, f.GetLength());
		arr.UnaccessData();

		m_ctlHexEdit.SetData(arr, 0);
	}
}

BOOL CHexEditDlgDlg::UpdateData( BOOL bSaveAndValidate )
{
	BOOL bRes = CDialog::UpdateData(bSaveAndValidate);
	if ( !bSaveAndValidate )
	{
		if ( m_ctlHexEdit.GetDigitsInData() != 2 )
			GetDlgItem(IDC_SHOWASCII)->EnableWindow ( FALSE );
		else
			GetDlgItem(IDC_SHOWASCII)->EnableWindow ( TRUE );
	}
	return bRes;
}

void CHexEditDlgDlg::OnExit() 
{
	if ( m_ctlHexEdit.GetDataModified() &&
		AfxMessageBox ( _T("Do you want to save changes?"), MB_ICONQUESTION | MB_YESNO ) == IDYES )
		OnSave();
	OnOK();
}

void CHexEditDlgDlg::OnSave() 
{
	// save changes
	if ( m_strFileName == _T("noname"))
	{
		CFileDialog dlg ( FALSE );
		
		if ( dlg.DoModal() == IDOK )
			m_strFileName = dlg.GetPathName();
		else
			return;
	}

	CFile f ( m_strFileName, CFile::modeCreate | CFile::modeWrite );

	void* buf;
	arr.AccessData ( &buf );
	f.Write ( buf, arr.GetOneDimSize());
	arr.UnaccessData();
	m_ctlHexEdit.SetDataModified(FALSE);
}

void CHexEditDlgDlg::OnNewfile() 
{
	m_strFileName = _T("noname");
	
	if ( arr.GetDim() == 0 )
	{
		for ( int i = IDC_COLUMNS; i <= IDC_SHOWADDR; i++)
		{
			CWnd* pWnd = GetDlgItem ( i );
			
			if ( pWnd )
				pWnd->EnableWindow ();
		}
	}

		SAFEARRAYBOUND rgsabound;
	rgsabound.cElements = 0;
	rgsabound.lLbound = 0;
	arr.Create(VT_UI1, 1, &rgsabound);

	// Create doesn't assert on zero length
	
	m_ctlHexEdit.SetData(arr, 0);
}

void CHexEditDlgDlg::OnDeltaposSpin1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	int iNewPos = pNMUpDown->iPos+pNMUpDown->iDelta;

	if ( iNewPos < 1 || iNewPos > 100 )
		*pResult = 1;
	else
	{
		*pResult = 0;
		m_nColumns = iNewPos;
		m_ctlHexEdit.SetColumns(m_nColumns);
		UpdateData(false);
	}
}

void CHexEditDlgDlg::OnKillfocusColumns() 
{
	OnChangeColumns();
}
